import 'package:osam/osam.dart';

part 'navigation_state.g.dart';

@HiveType(typeId: 223)
// ignore: must_be_immutable
class NavigationState extends BaseState<NavigationState> {
  @HiveField(0)
  final List<String> _routes;

  NavigationState(this._routes);

  ValueStream<List<String>> get routesStream => propertyStream((_) => _routes);

  void push(String route) => update((_) => _routes.add(route));

  void pop() => update((_) => _routes.removeLast());

  void pushReplacement(String route) => update((_) => _routes[_routes.length - 1] = route);

  void pushAndRemoveUntil(String route) => update((_) {
        _routes.clear();
        _routes.add(route);
      });

  void popUntil(String route) {
    if (_routes.contains(route)) {
      update((_) {
        while (_routes.last != route) {
          _routes.removeLast();
        }
      });
    }
  }

  @override
  List<Object> get props => [_routes];
}

@HiveType(typeId: 222)
// ignore: must_be_immutable
class TabNavigationState extends BaseState<TabNavigationState> {
  @HiveField(0)
  String tab;

  TabNavigationState(this.tab);

  @override
  List<Object> get props => [tab];
}

void registerOsamAdapters() {
  Hive.registerAdapter(NavigationStateAdapter());
  Hive.registerAdapter(TabNavigationStateAdapter());
}
