import 'package:flutter/material.dart';

class LoadingWrapper extends StatelessWidget {
  final Widget child;
  final ValueNotifier<bool> isLoading;
  final Color indicatorColor;

  const LoadingWrapper({Key key, this.isLoading, this.child, this.indicatorColor}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: <Widget>[
        child,
        Positioned(
          top: 0,
          child: ValueListenableBuilder<bool>(
              valueListenable: isLoading,
              builder: (_, value, __) => SizedBox(
                    width: MediaQuery.of(context).size.width,
                    height: 3,
                    child: value
                        ? LinearProgressIndicator(
                            backgroundColor: Colors.transparent,
                            valueColor: AlwaysStoppedAnimation(indicatorColor),
                          )
                        : null,
                  )),
        )
      ],
    );
  }
}
